aboutsummaryrefslogtreecommitdiff
path: root/nagios-exists
diff options
context:
space:
mode:
authorTom Ryder <tom@sanctum.geek.nz>2016-06-20 13:08:15 +1200
committerTom Ryder <tom@sanctum.geek.nz>2016-06-20 13:08:15 +1200
commitcdc34fa78b326bd241aae7399190c739e25bf025 (patch)
tree2d12fdf161b74dcde13baf33bb46f0137f443952 /nagios-exists
parentRemove silly symlinks (diff)
downloadnagscripts-3023a404a59a8ec51e9ebe0b5fea3a4f9f8ddf0c.tar.gz
nagscripts-3023a404a59a8ec51e9ebe0b5fea3a4f9f8ddf0c.zip
Update to latest version with MKLivestatusmk-livestatus
No longer using NDOUtils at work, these are much nicer and more likely to work with any given Nagios installation now anyway. Added nagios-data-search, nagios-downtstream-list, nagios-exists, nagios-problem-list, and nagios-unhandled-list.
Diffstat (limited to 'nagios-exists')
-rwxr-xr-xnagios-exists79
1 files changed, 79 insertions, 0 deletions
diff --git a/nagios-exists b/nagios-exists
new file mode 100755
index 0000000..c9e6114
--- /dev/null
+++ b/nagios-exists
@@ -0,0 +1,79 @@
+#!/usr/bin/env bash
+
+#
+# nagios-exists(1) -- Return an exit status corresponding to whether HOST or
+# HOST/SERVICE exists in Nagios. Mostly for use in scripts.
+#
+# $ nex abc-example-mc-1
+# $ nex webhost/HTTP
+#
+# Author: Tom Ryder <tom@sanctum.geek.nz>
+# Copyright: 2016
+#
+
+# Name self
+self=nagios-exists
+
+# Usage printing function
+usage() {
+ printf 'USAGE: %s HOST[/SERVICE]\n' "$self"
+}
+
+# Handle options, just -h help at the moment
+OPTIND=1
+while getopts 'h' opt ; do
+ case "$opt" in
+ h)
+ usage
+ exit 0
+ ;;
+ '?')
+ usage >&2
+ exit 1
+ ;;
+ esac
+done
+shift "$((OPTIND-1))"
+
+# We need exactly one argument remaining
+if (($# != 1)) ; then
+ usage >&2
+ exit 1
+fi
+
+# Define the path to the Livestatus socket
+socket=${MK_LIVESTATUS_SOCKET:-/usr/local/nagios/var/rw/live}
+
+# Which query to run depends on what the argument looks like.
+case $1 in
+
+ # If there's a slash in the argument, it's a host/service tuplet.
+ */*)
+ host_name=${1%/*}
+ service_description=${1#*/}
+ while read -r _ ; do
+ exit
+ done < <(unixcat "$socket" <<EOF
+GET services
+Columns: host_name service_description
+Filter: host_name = $host_name
+Filter: service_description = $service_description
+EOF
+ )
+ exit 1
+ ;;
+
+ # Otherwise, assume it's a host.
+ *)
+ host_name=$1
+ while read -r _ ; do
+ exit
+ done < <(unixcat "$socket" <<EOF
+GET hosts
+Columns: host_name
+Filter: host_name = $host_name
+EOF
+ )
+ exit 1
+ ;;
+esac